# Birdie | Task 1
# Author: Simon Stueckemann
# Date: 2/2/2015
# Version 0.1
#
# Birdie is a simple game that lets the player fly a bird through the clouds.

import sys, pygame
from pygame.locals import *

ANIMATE_BIRD_E = USEREVENT + 1

# The following represents a bird on the screen. 
# You can create a new bird by typing "Bird()". You do not have to understand 
# the following program code. We will discuss some of it more in the coming weeks.
class Bird(pygame.sprite.Sprite):
    def __init__(self):
        super(Bird, self).__init__()
        self.images = []
        self.images.append(pygame.image.load('flappingbird-0.tiff'))
        self.images.append(pygame.image.load('flappingbird-1.tiff'))
        self.images.append(pygame.image.load('flappingbird-2.tiff'))
        self.images.append(pygame.image.load('flappingbird-3.tiff'))

        self.index = 0
        self.image = self.images[self.index]
        self.rect = pygame.Rect(100, 130, 95, 108)

    def move_up(self):
        if self.rect.y - 5 >= 0:
            self.rect.y -= 5

    def move_down(self):
        if self.rect.y + 5 + self.rect.height <= 424:
            self.rect.y += 5

    def move_right(self):
        if self.rect.x + self.rect.width <= 624:
            self.rect.x += 5

    def move_left(self):
        if self.rect.x - 5 >= 0:
            self.rect.x -= 5

    def flap(self):
        self.index += 1
        if self.index >= len(self.images):
            self.index = 0
        self.image = self.images[self.index]


# Pygame helps us set up our program for game development
# This line makes sure the computer knows that we want to make a game
# In technical terms, this "initialises the pygame library"
pygame.init()

# The very first step is to create a window where we can draw the 
# bird and the cloud
width = 624
height = 424
# Instead of keeping width and height separately, we list them together as a "pair": (624, 424)
size = (width, height)


# Task 1: Enter your code here


# Task 2: Enter your code here


# Task 3: Enter your code here



# Do not worry about the next three lines yet. Feel free to ask about them though if you are interested.
clock = pygame.time.Clock()
pygame.time.set_timer(ANIMATE_BIRD_E, 100)
pygame.key.set_repeat(1, 30)

# Here we handle all of the special events that might come in
# For example, if a user wants to exit the game this is done here
def handle_events(events):
    for event in events:
        if event.type == pygame.QUIT: 
            sys.exit()

# This is the main game event loop which contains the program code 
# that is repeated until the player wants to end the game.
while True:
    clock.tick(30)
    handle_events(pygame.event.get())


    # Finally, after everything is drawn, we tell the computer that we are 
    # ready to display the new changes to the user
    pygame.display.flip()
